
DropCountOPT={};
local list;

function DropCountOPT:OnShow()
	list=LCDC_ListOfOptions_List;
	list:DMClear();

	-- Populate options list
	local entry,state;

	entry=list:DMAdd("Minimap",nil,-1); entry.Tooltip=nil;
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.VendorMinimap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show vendors",state,0,"Interface\\GROUPFRAME\\UI-Group-MasterLooter");
		entry.Tooltip={"Toggle tracking vendors on minimap"};
		entry.DB={ Base="DB", Setting="VendorMinimap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.RepairMinimap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show repair-vendors",state,0,"Interface\\GossipFrame\\VendorGossipIcon");
		entry.Tooltip={"Toggle tracking of repair-vendors on minimap","This setting has no effect if \"Show vendors\" is also checked."};
		entry.DB={ Base="DB", Setting="RepairMinimap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.BookMinimap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show books",state,0,"Interface\\Spellbook\\Spellbook-Icon");
		entry.Tooltip={"Toggle tracking of readable books on minimap"};
		entry.DB={ Base="DB", Setting="BookMinimap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.QuestMinimap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show quest givers",state,0,"Interface\\QuestFrame\\UI-Quest-BulletPoint");
		entry.Tooltip={"Toggle tracking of quest givers on minimap"};
		entry.DB={ Base="DB", Setting="QuestMinimap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.TrainerMinimap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show trainers",state,0);
		entry.Tooltip={"Toggle tracking of trainers on minimap"};
		entry.DB={ Base="DB", Setting="TrainerMinimap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.ForgeMinimap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show forges",state,0,DropCountXML.ForgeIcon);
		entry.Tooltip={"Toggle tracking of forges on minimap"};
		entry.DB={ Base="DB", Setting="ForgeMinimap" };

	entry=list:DMAdd("Worldmap",nil,-1); entry.Tooltip=nil;
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.VendorWorldmap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show vendors",state,0,"Interface\\GROUPFRAME\\UI-Group-MasterLooter");
		entry.Tooltip={"Toggle tracking vendors on world map"};
		entry.DB={ Base="DB", Setting="VendorWorldmap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.RepairWorldmap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show repair-vendors",state,0,"Interface\\GossipFrame\\VendorGossipIcon");
		entry.Tooltip={"Toggle tracking of repair-vendors on world map","This setting has no effect if \"Show vendors\" is also checked."};
		entry.DB={ Base="DB", Setting="RepairWorldmap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.BookWorldmap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show books",state,0,"Interface\\Spellbook\\Spellbook-Icon");
		entry.Tooltip={"Toggle tracking of readable books on world map"};
		entry.DB={ Base="DB", Setting="BookWorldmap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.QuestWorldmap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show quest givers",state,0,"Interface\\QuestFrame\\UI-Quest-BulletPoint");
		entry.Tooltip={"Toggle tracking of quest givers on world map"};
		entry.DB={ Base="DB", Setting="QuestWorldmap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.TrainerWorldmap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show trainers",state,0);
		entry.Tooltip={"Toggle tracking of trainers on world map"};
		entry.DB={ Base="DB", Setting="TrainerWorldmap" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.ForgeWorldmap) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show forges",state,0,DropCountXML.ForgeIcon);
		entry.Tooltip={"Toggle tracking of forges on world map"};
		entry.DB={ Base="DB", Setting="ForgeWorldmap" };

	entry=list:DMAdd("Misc",nil,-1); entry.Tooltip=nil;
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.GUILD) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Share data with guild",state,0);
		entry.Tooltip={"Share collected data with DropCount users in your guild."};
		entry.DB={ Base="DB", Setting="GUILD" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_DB.RAID) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Share data with group or raid",state,0);
		entry.Tooltip={"Share collected data with DropCount users in your party."};
		entry.DB={ Base="DB", Setting="RAID" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.ShowZoneMobs) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Use drop-data from current zone only",state,0);
		entry.Tooltip={"Only use current zone data for calculating results, goals or displaying data."};
		entry.DB={ Base="Character", Setting="ShowZoneMobs" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.ShowSingle) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Show single dropped items",state,0);
		entry.Tooltip={"Disable to hide items that has dropped only once from a creature."};
		entry.DB={ Base="Character", Setting="ShowSingle" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.NoTooltip) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Hide \"Best known area\" from items' tooltips.",state,0);
		entry.Tooltip={"Disable to see where an item have the best drop chance in items' tooltip."};
		entry.DB={ Base="Character", Setting="NoTooltip" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.CompactView) then state=DM_STATE_CHECKEDinc; end
		entry=list:DMAdd("Use compact mode for tooltips",state,0);
		entry.Tooltip={"Enable for more compact tooltips. Some information will not show with this setting enabled."};
		entry.DB={ Base="Character", Setting="CompactView" };

	local entries;
	entry=list:DMAdd("Minimalistic database (relog recommended)",nil,-1); entry.Tooltip={"Enabling any of these options can potentially save a lot memory.","It will also delete any data you may have in said categories.","These actions are ACCOUNT SPECIFIC and can not be undone,","meaning what you do here will show in your other characters."};
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.DontFollowMobsAndDrops) then state=DM_STATE_CHECKEDinc; end
		entries=self:TableLength(LootCount_DropCount_DB.Count)+self:TableLength(LootCount_DropCount_DB.Item);
		entry=list:DMAdd("Delete item drop-rates from mobs ("..entries.." entries)",state,0);
		entry.Tooltip={"WARNING!","This option will delete ALL data about creatures and the items they drop."};
		entry.DB={ Base="DB", Setting="DontFollowMobsAndDrops" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.DontFollowQuest) then state=DM_STATE_CHECKEDinc; end
		entries=self:TableLength(LootCount_DropCount_DB.Quest,true);
		entry=list:DMAdd("Delete quests ("..entries.." entries)",state,0);
		entry.Tooltip={"WARNING!","This option will delete ALL data about quest-givers."};
		entry.DB={ Base="DB", Setting="DontFollowQuest" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.DontFollowVendors) then state=DM_STATE_CHECKEDinc; end
		entries=self:TableLength(LootCount_DropCount_DB.Vendor);
		entry=list:DMAdd("Delete vendors ("..entries.." entries)",state,0);
		entry.Tooltip={"WARNING!","This option will delete ALL data about vendors."};
		entry.DB={ Base="DB", Setting="DontFollowVendors" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.DontFollowBooks) then state=DM_STATE_CHECKEDinc; end
		entries=self:TableLength(LootCount_DropCount_DB.Book);
		entry=list:DMAdd("Delete books ("..entries.." entries)",state,0);
		entry.Tooltip={"WARNING!","This option will delete ALL data about readable books."};
		entry.DB={ Base="DB", Setting="DontFollowBooks" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.DontFollowTrainers) then state=DM_STATE_CHECKEDinc; end
		entries=self:TableLength(LootCount_DropCount_DB.Trainer,true);
		entry=list:DMAdd("Delete trainers ("..entries.." entries)",state,0);
		entry.Tooltip={"WARNING!","This option will delete ALL data about profession trainers."};
		entry.DB={ Base="DB", Setting="DontFollowTrainers" };
	state=DM_STATE_UNCHECKEDinc; if (LootCount_DropCount_Character.DontFollowForges) then state=DM_STATE_CHECKEDinc; end
		entries=self:TableLength(LootCount_DropCount_DB.Forge);
		entry=list:DMAdd("Delete forges ("..entries.." entries)",state,0);
		entry.Tooltip={"WARNING!","This option will delete ALL data about forges."};
		entry.DB={ Base="DB", Setting="DontFollowForges" };
end

function DropCountOPT:TableLength(t,downone)
	local count=0;
	for _,nest in pairs(t) do
		if (downone and type(nest)=="table") then
			for _ in pairs(nest) do count=count+1; end	-- go down this level as well
		end
		count=count+1;									-- count this top-level entry
	end
	return count;
end
